#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-session-manager-2.1.2/generated/presence_dbus_common.h"

namespace gnome {
namespace SessionManager {

class PresenceProxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<PresenceProxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<PresenceProxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void SetStatus(
        guint32 status,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetStatus_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetStatus_sync(
        guint32 status,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetStatusText(
        const Glib::ustring & status_text,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetStatusText_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetStatusText_sync(
        const Glib::ustring & status_text,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    guint32 status_get(bool *ok = nullptr);
    void status_set(guint32, const Gio::SlotAsyncReady &);
    void status_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void status_set_sync(guint32);
    sigc::signal<void> &status_changed() {
        return m_status_changed;
    }

    Glib::ustring status_text_get(bool *ok = nullptr);
    void status_text_set(const Glib::ustring &, const Gio::SlotAsyncReady &);
    void status_text_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void status_text_set_sync(const Glib::ustring &);
    sigc::signal<void> &status_text_changed() {
        return m_status_text_changed;
    }

    sigc::signal<void, guint32 > StatusChanged_signal;
    sigc::signal<void, Glib::ustring > StatusTextChanged_signal;

    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    PresenceProxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

    sigc::signal<void> m_status_changed;
    sigc::signal<void> m_status_text_changed;
};

}// SessionManager
}// gnome

